//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fschdir.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"



// CHANGE CURRENT DIRECTORY

int FSChdir(char *name)
{
FS_FILE *entry,*old;
int error;
FS_VOLUME *fs;

error=FSInit();
if(error!=FS_OK) return error;


entry=(FS_FILE *) malloc(sizeof(FS_FILE));
if(entry==NULL) return FS_ERROR;

// CLEAN ENTRY
memset((void *)entry,0,sizeof(FS_FILE));


// CHECK IF CARD IS PRESENT

error=FSVolumePresent(FSystem.Volumes[FSystem.CurrentVolume]);
if(error!=FS_OK) { free(entry); return error; }


error=FSFindFile(name,entry,TRUE);
if((error!=FS_OK) && (error!=FS_OPENDIR)) { free(entry); return error; }

if(error==FS_OK) {
// NEWLY OPENED DIR
//printf("chdir to new dir\n");
if(!(entry->Attr&FSATTR_DIR)) {
// CLEANUP PROCEDURE
while(entry!=NULL) entry=FSFreeFile(entry);
return FS_NOTFOUND;
}


fs=FSystem.Volumes[entry->Volume];


// GET FILE CLUSTER CHAIN
error=FSGetChain(entry->FirstCluster,&entry->Chain,fs);

if(error!=FS_OK) {
while(entry!=NULL) entry=FSFreeFile(entry);
return FS_ERROR;
}
entry->FileSize=FSGetChainSize(&entry->Chain);
}
else {
// USE AN ALREADY OPENED DIRECTORY
old=entry;
entry=entry->Dir;
free(old);
if(!(entry->Attr&FSATTR_DIR)) return FS_NOTFOUND;
fs=FSystem.Volumes[entry->Volume];
}



old=fs->CurrentDir;
fs->CurrentDir=entry;
while(old!=NULL) old=FSFreeFile(old);

return FS_OK;

}

