//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
extern "C" {
#include <ggl.h>
}

#include "memblock.h"
#include "gstring.h"
#include "gui.h"
#include "resources.h"



gStaticTextWrap::gStaticTextWrap(gControl& _Parent,int x,int y, int width, const char *_Text,gFont *f,int color)
: gStaticText(_Parent,x,y,_Text,f,color)
{
	maxwidth=width;
	RecalcSize();
}

gStaticTextWrap::~gStaticTextWrap()
{
}

void gStaticTextWrap::Update(gUpdate *u)
{
int px,py;
char *ptr=Text;
py=posy;
px=posx;
while(*ptr) {
Parent->DrawText(px,py,ptr,&Font,Color);
while((*ptr!=0) && (*ptr!='\n') && (*ptr!='\r')) ++ptr;
if(*ptr=='\n') ++ptr;
if(*ptr=='\r') ++ptr;
py+=Font.TextHeight();
// TODO: RECALC px FOR PROPER JUSTIFICATION
}

}

void gStaticTextWrap::SetText(const char *_Text)
{
if(Text) { delete Text; Text=NULL; }

Text=new char[strlen(_Text)+1];

// CLEAN OLD TEXT
gUpdate u;
u.clipx=posx;
u.clipy=posy;
u.clipx2=posx+sizex-1;
u.clipy2=posy+sizey-1;

Parent->ClearClipRegion();
Parent->RedrawBackground(&u);

if(!Text) return;

strcpy(Text,_Text);

RecalcSize();

u.clipx=posx;
u.clipy=posy;
u.clipx2=posx+sizex-1;
u.clipy2=posy+sizey-1;

Parent->Invalidate(&u);

}


void gStaticTextWrap::RecalcSize()
{
	int stblank=0, wordw=0, nlines=1, total=0;
	char *ptr=Text,*wordstart=Text;

	sizex=0;
	
	while(*ptr) {
	if(*ptr=='\n') {
		++ptr;
		if(*ptr=='\r') ++ptr;
		++nlines;
		total+=wordw+stblank;
		if(total>sizex) sizex=total;
		total=0;
		wordw=0;
		stblank=0;
	}
	if(*ptr=='\r') {
		++ptr;
		++nlines;
		total+=wordw+stblank;
		if(total>sizex) sizex=total;
		total=0;
		wordw=0;
		stblank=0;
	}
	if(*ptr==' ') {
	if(wordw==0) stblank+=Font.CharWidth(*ptr);
	else {
		if(total+wordw+stblank>maxwidth) {
			// WORD WRAP
			if(*wordstart==' ') {
				*wordstart='\n';
				++nlines;
				if(total>sizex) sizex=total;
				total=wordw+stblank-Font.CharWidth(' ');
				wordw=0;
				stblank=Font.CharWidth(' ');
				wordstart=ptr;
				++ptr;
				continue;
			}
		}
				total+=wordw+stblank;
				wordw=0;
				stblank=Font.CharWidth(' ');
				wordstart=ptr;
				++ptr;
				continue;
	}
	}
	
	wordw+=Font.CharWidth(*ptr);
	++ptr;
	
}
	total+=wordw+stblank;
	if(total>sizex) sizex=total;
	sizey=Font.TextHeight()*nlines;
}


void gStaticTextWrap::CalcSize(const char *Text,gFont *Font,int maxwidth,int *szx,int *szy)
{
	int stblank=0, wordw=0, nlines=1, total=0;
	const char *ptr=Text,*wordstart=Text;

	*szx=0;
	
	while(*ptr) {
	if(*ptr=='\n') {
		++ptr;
		if(*ptr=='\r') ++ptr;
		++nlines;
		total+=wordw+stblank;
		if(total>*szx) *szx=total;
		total=0;
		wordw=0;
		stblank=0;
	}
	if(*ptr=='\r') {
		++ptr;
		++nlines;
		total+=wordw+stblank;
		if(total>*szx) *szx=total;
		total=0;
		wordw=0;
		stblank=0;
	}
	if(*ptr==' ') {
	if(wordw==0) stblank+=Font->CharWidth(*ptr);
	else {
		if(total+wordw+stblank>maxwidth) {
			// WORD WRAP
			if(*wordstart==' ') {
				++nlines;
				if(total>*szx) *szx=total;
				total=wordw+stblank-Font->CharWidth(' ');
				wordw=0;
				stblank=Font->CharWidth(' ');
				wordstart=ptr;
				++ptr;
				continue;
			}
		}
				total+=wordw+stblank;
				wordw=0;
				stblank=Font->CharWidth(' ');
				wordstart=ptr;
				++ptr;
				continue;
	}
	}
	
	wordw+=Font->CharWidth(*ptr);
	++ptr;
	
}
	total+=wordw+stblank;
	if(total>*szx) *szx=total;
	*szy=Font->TextHeight()*nlines;
}
