//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <hpgcc3.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_flip(void)
{
    hpg_init();

    unsigned int volatile *LCDCON1 = (int *) 0x7300000;
    unsigned int volatile *LCDSADDR1 = (int *) 0x7300014;
    unsigned int volatile *LCDSADDR2 = (int *) 0x7300018;

    if (__mg->hpg_stdscreen->fb == __mg->hpg_stdscreen->drawfb) return;

    char *temp = (char *) (__mg->hpg_stdscreen->fb);
    __mg->hpg_stdscreen->fb = __mg->hpg_stdscreen->drawfb;
    __mg->hpg_stdscreen->drawfb = temp;

    int vdiff = (*LCDSADDR2 & 0x001FFFFF) - (*LCDSADDR1 & 0x001FFFFF);

    /*
     * If switching between video buffers in two different banks, then
     * the LCD controller needs to be disabled to do it.  This is not
     * recommended, but is potentially beyond our control unless we make
     * some assumptions about malloc behavior.
     */
    int bankswitch = 0;
    if ((((int) __mg->hpg_stdscreen->drawfb) & 0xFFE00000)
        != (((int) __mg->hpg_stdscreen->fb) & 0xFFE00000))
    {
        bankswitch = 1;
    }

    lcd_sync();
    (*LCDCON1) &= ~1; //turn LCD controller off

    if (__mg->hpg_stdscreen->fb == DEFAULT_PLANE)
    {
        //go back to default buffer

        *LCDSADDR1 = 0x20000000 + ((__mg->__console_vars->__display_buf & 0xFFFF) >> 1);
        *LCDSADDR2 = 0x20000000 + ((__mg->__console_vars->__display_buf & 0xFFFF) >> 1) + vdiff;
    }
    else
    {
        *LCDSADDR1 = (((int)
            sys_map_v2p((unsigned) __mg->hpg_stdscreen->fb)) >> 1);
        *LCDSADDR2 = (((int)
            sys_map_v2p((unsigned) __mg->hpg_stdscreen->fb)) >> 1) + vdiff;
    }

    (*LCDCON1) |= 1; //turn controller back on
}
