//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

// CALCULATE 10^X WITH 64-BIT PRECISION
// RETURN A BASE-2 EXPONENT + A 64-BIT MANTISSA
// MORE ACCURATE THAN STANDARD POW AND IPOW

void xr_10pow(int exp10,XREAL *value)
{
unsigned long long val=0x8000000000000000LL;
int exp2=-63;

while(exp10>=3) {
val=val-(((val>>1)+(val>>2)+16)>>5);
exp10-=3;
exp2+=10;
if(!(val&0x8000000000000000LL)) { val<<=1; exp2--; }
}

while(exp10>0) {
val=val-(((val>>1)+(val>>2)+1)>>1);
exp10--;
exp2+=4;
if(!(val&0x8000000000000000LL)) { val<<=1; exp2--; }
}


value->Exp=exp2;
value->Mant=val;
value->Sign=0;
}
