//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// Simple Stream Library for HP49g+


#include <hpgcc_config.h>
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "kos.h"
#include <master_globals.h>
#include <fsystem.h>


FILE *fopen(const char *_fn, const char *mode)
{
    U32 fmode;
    FILE *f = NULL;
    int error;
    
    f=malloc(sizeof(FILE));
    if(!f) return NULL;

    f->file=NULL;
    f->cacheused=0;
    f->writecache=NULL;

    if (*mode == 'w') 
        fmode = FSMODE_WRITE;
    else if (*mode == 'a')
        fmode = FSMODE_APPEND;
    else // default
        fmode = FSMODE_READ;
    
    error=FSOpen((char *)_fn,fmode,&(f->file));
    if(error!=FS_OK) {
    	free(f);
     	return NULL;
    }
    
    return f;
}


