//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

 


// $Id: newton.c 514 2007-11-18 03:11:26Z ingo $

#include <math.h>

// ROMLIB CHECKED
// < ibl ; 2006-04-03 >

double
newton(DFUNC1 f, double x0,double y)
{
    #define MAXTRIES 100
    #define EPSILON 1.0e-6
    
    double y0;
    int tries = 0;
    
    while (++tries < MAXTRIES && fabs(y0=(*f)(x0)-y) > EPSILON) 
        x0 -= y0/df(1,f,x0);
        
    return tries < MAXTRIES ? x0 :  MATH_ERR_NEWTON_INVALID;
}
