//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: _vsscanf.c 524 2008-01-12 16:13:19Z claudio $

// ROMLIB CHECKED
// < ibl ; 2006-04-06 >

#include <hpgcc3.h>
#include <stdarg.h>


/*************************************************************
 !!! CAUTION !!!
 
 Work in progress.
 This function isn't yet fully implemented feature wise.
 Also expect lots of bugs!
 
 *************************************************************/

// TODO: Add missing features, unit testing

#define WHITESPACE " \t\r\n"


int
_vsscanf(const char *str, const char *format, va_list ap)
{
    int items = 0;
    int chars = 0;
    char *flag_chars = "ahlLq";
    char *conv_chars = "%dDiouxXfegEsc[pn";
    char skip_buff[2];
    const char *p;
    
    skip_buff[1] = '\0'; // String delimiter
    
    for (p = format; *p ; p++) {
        
        if (*p != '%') {
            
            if(strchr(WHITESPACE,*p)) {
                while (strchr(WHITESPACE,*str)) {
                    str++;
                    chars++;
                }
                continue;
            }
            
            else if (*p == *str) {
                chars++;
                str++;
                continue;
            }
            
            else goto stop;
        }
        
        // cond: *p == '%' 

        p++;
        
        
        int star,width;
        char flag,conv;
        
        width = 0;
        
        // first check for possible flags ...
        
        if((star = *p == '*'))
            p++;
        
        if((flag = strchr(flag_chars,*p) ? *p : '\0'))
            p++;
        
        
 
        
        // now for a possible field width ...
        
        if (isdigit(*p))
            for ( ; isdigit(*p) ; p++)
                width = 10*width + (*p & 0xF);
 
        // check for 'll'
         
         if (flag == 'l' && *p == 'l') {
             flag = 'L'; p++;
         }
         
         if (flag == 'q')
             flag = 'L';       
            
        // get conversion char & check validity ...

        if (! strchr(conv_chars,conv = *p))
            goto stop;
        
        // set default width, if necessary
        
        if (!width)
            width = conv == 'c' ? 1 : 0x7fffffff;
        
        int skip_to_delim = 1;
        
        char *skip_set = strchr(WHITESPACE,(skip_buff[0]=*(p+1))) ? WHITESPACE : skip_buff ;
        
        switch (conv) {
            
            int base;
            
            case '%':
                if (*str != '%') goto stop;
                break;
                
            case 'f':
            case 'e':
            case 'g':
            case 'E':
                
                if (! star) {
                    double *dval = va_arg(ap,double *);
                    *dval = atof(str);
                    items++;
                }
                
                break;
                
            
            case 'd':
            case 'D':

                if (!star) {
                 
                    if (flag == 'L') {
                        LONGLONG *ll = va_arg(ap,LONGLONG *);
                        *ll = atoll(str);
                    }
                    else if (flag == 'h') {
                        short *ii = va_arg(ap,short *);
                        *ii = (short)(atoi(str) & 0xFFFF);
                    }
                    else {
                        int * ii = va_arg(ap,int *);
                        *ii = atoi(str);
                    }
                    
                    items++;
                }
                
                break;
                
            
            case 'u':
            case 'x':
            case 'X':
            case 'o':
                 
            base = conv == 'u' ? 10 : (conv == 'o' ? 8 : 16);
                   
            if (!star) {
                 
                    if (flag == 'L') {
                        ULONGLONG *ll = va_arg(ap,ULONGLONG *);
                        *ll = atoull_base(str,base);
                    }
                    else if (flag == 'h') {
                        unsigned short *ii = va_arg(ap, unsigned short *);
                        *ii = (unsigned short)(atoui_base(str,base) & 0xFFFF);
                    }
                    else {
                        unsigned int * ii = va_arg(ap,unsigned int *);
                        *ii = atoui_base(str,base);
                    }
                    
                    items++;
                }
                
                break;
                
    
            case 'i':
            case 'p':
            
                if (! star) {
                
                    int minus;
                    char *u = str;
                    
                    base = 10;
                    
                    if ((minus = *u == '-'))
                        u++;
                    
                    if (*u == '0') {
                        u++;
                        if (*u == 'x' || *u == 'X') {
                            u++;
                            base = 16;
                        }
                        else
                            base = 8;
                    }
                    
                    // cond: u points to first significant digit
                    
                    if (conv == 'p') {
                        
                        void **p = va_arg(ap,void **);
                        *p = (void *) atoi_base(u,base);
                    }
                    else    
                        
                        if (flag == 'L') {
                            LONGLONG * ii = va_arg(ap,LONGLONG *);
                            LONGLONG z = atoll_base(u,base);
                            *ii = minus ? -z : z;
                        }
                        else if (flag == 'h') {
                            short *ii = va_arg(ap,short *);
                            short z = (short)(atoi_base(u,base) & 0xFFFF);
                            *ii = minus ? -z : z;
                        }
                        else {
                            int *ii = va_arg(ap, int *);
                            int z = atoi_base(u,base);
                            *ii = minus ? -z : z;
                        }
                    
                    items++;
                }
            
            break;
            

            case 's':
            case 'c':
                
            {

                const char *u = str;
                int c = 0;
                
                skip_to_delim = conv == 's';
                
                while (*u && c < width) {
                    if (conv == 's' && strchr(WHITESPACE,*u))
                        break;
                    u++;
                    c++;
                }
                
                if (! star ) {
                    
                    char *t;
                    
                    if (flag == 'a') {
                        char **sval = va_arg(ap,char **);
                        t = *sval = (char *) malloc(c + 1);
                    }
                    else 
                        t = va_arg(ap,char *);
                    
                    strncpy(t,str,c);
                    
                    if ((conv == 's') || ((conv == 'c') && (flag == 'a')))
                        *(char *)((unsigned long) t + c) = '\0';
                    
                    
                    items++;
                    
                }
                
            }
            
            break;
            
            case 'n':
                // return # of chars read so far (metadata conversion)
                {
                    int *ival = va_arg(ap,int *);
                    *ival = chars;
                    
                }
            break;
                
        }
        
        // now skip chars in source string up to matching delimiter(s) ...    
     
        if (skip_to_delim) {
            while(*str && !strchr(skip_set,*str)) {
                chars++ ; str++;
            }
         
        }
            
        else {
            chars += width;
            str = (char *) ((unsigned long) str + width);
        }    
                
    
    }
    
stop:

    return items;
}


