//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



/* $Id: realloc.c 599 2008-09-01 16:37:15Z claudio $ */


#include <stdlib.h>
#include <string.h> // for memcpy
#include <master_globals.h>

#define CAST_INT    int
#define BRKSIZE        4096

#define PTRSIZE        ((int) sizeof(void *))
#ifndef ALIGN
#define ALIGN(x,a)    (((x) + (a - 1)) & ~(a - 1))
#endif
#define NEXT_SLOT(p)    (* (void **) ((p) - PTRSIZE))
#define NEXT_FREE(p)    (* (void **) (p))


// ROMLIB CHECKED

extern BOOL __isusedheapptr(void *ptr);





void *
realloc(void *oldp, size_t size)
{
  register char *prev, *p, *next, *new;
  char *old = oldp;
  register size_t len, n;

  if (!old) return malloc(size);
  else if (!size) {
    free(oldp);
    return NULL;
  }
  
  // IMPROVED HEAP SAFETY CHECKS BY CLAUDIO 12-2-2006
  if(!__isusedheapptr(old)) return NULL;
  
  
  len = ALIGN(size, PTRSIZE) + PTRSIZE;
  next = NEXT_SLOT(old);
  n = (int)(next - old);            
 
  for (prev = 0, p = __mg->_malloc_empty; p != 0; prev = p, p = NEXT_FREE(p)) {
    if (p > next)
        break;
    if (p == next) {    
        NEXT_SLOT(old) = NEXT_SLOT(p);
        if (prev)
            NEXT_FREE(prev) = NEXT_FREE(p);
        else
            __mg->_malloc_empty = NEXT_FREE(p);
        next = NEXT_SLOT(old);
        break;
    }
  }
  new = old + len;
  
  if (new <= next && new >= old) {        
    if (new + PTRSIZE < next) {        
        NEXT_SLOT(new) = next;
        NEXT_SLOT(old) = new;
        free(new);
    }
    return old;
  }
  if ((new = malloc(size)) == NULL)        
    return NULL;
  memcpy(new, old, n);                
  free(old);
  return new;
}
