//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



//sets the RTC Tick Period. By default it is 8hz. If modified, you 
//should restore it to this speed
//at the end of your program eg call with n=15
//period = (n+1)/128 seconds. N _must_ be between 1 and 127

// modified for preserving/querying state
// < ibl ; 2004-12-03 >

// state preservation disabled to prevent crash
// < chris ; 2005-01-10 >

// re-enabled state preservation by circumventing (possible) gcc bug
// i.e. 'static unsigned char' declaration replaced by 'static int', which obviously works
// < ibl ; 2005-01-11 >

// Move current period to a non-static variable, so that it can be accessed
// from outside this file.
// < chris ; 2005-01-23 >


// ROMLIB CHECKED - NOT TO ROM

int _sys_RTCTickPeriod = 15;

unsigned char
sys_setRTCTickPeriod(unsigned char n)
{
    
//     causes a system crash due to a (possible) gcc bug!
//    static unsigned char old_period = 15; // System default
//    unsigned char r;

    //<Benjamin 22/05/2005> removed the (unneeded ?) following line
    //static int old_period = 15; // System default
    
    int r;
    
    unsigned char volatile * TICNT = (char*) 0x7B00047;

    if((n==0)||(n>127))
    {
        return (unsigned char) _sys_RTCTickPeriod;
    }
    
    r = _sys_RTCTickPeriod;
    _sys_RTCTickPeriod = n;
    
    *TICNT = (unsigned char) (n | 0x80); //set bit 7, enable tick interrupt
    
    return (unsigned char) r;
}
