//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: launch_align_code.c 393 2007-03-04 23:17:29Z ingo $

#include <hpgcc3.h>
#include "launcher.h"


// APPEND CODE MMU TABLE TO THE CURRENT MMU TABLE, REALIGN IF NECESSARY

int launch_align_code(int *mmu_table,int code_addr,int codesize, SAT_CPU *cpu)
{
int tblpages=((int)mmu_table)&0xfff;
int codepages=(codesize+2047)>>11;

// FORCE CODE ALIGNMENT WHEN CODE RUNS FROM TEMPOB
if( (((code_addr>>1)>=__launch_s2a(__launch_peek(SAT_TEMPOB,5,cpu),cpu)) && ((code_addr>>1)<=__launch_s2a(__launch_peek(SAT_TEMPTOP,5,cpu),cpu)))
// AND WHEN IT'S NOT ALIGNED, OF COURSE
    || (code_addr&2047)) {
// CODE NEEDS ALIGNMENT
if(tblpages-((codepages+3)&(~3))<16) return 0;		// MINIMUM 16 KB OF RAM REQUIRED TO RUN A PROGRAM


// CREATE CODE MMU TABLE
int *dest,*tblptr,needpages,pageval, count;
needpages=((codepages+3)&(~3));
needpages>>=1;
tblptr=mmu_table;
mmu_table=(int *) (((unsigned int)mmu_table&(~0xfff))|512);

while(needpages--!=0)
{
pageval=(*(--tblptr))&(~0xfff);
// COPY CODE TO ALIGNED POSITION
for(count=0,dest=(int *)pageval;count<1024;++count,++dest)
{
*dest=__launch_peekarm(code_addr,8,cpu);
code_addr+=8;
}
pageval|=0x3f;
*mmu_table++=pageval;
pageval+=1024;
*mmu_table++=pageval;
pageval+=1024;
*mmu_table++=pageval;
pageval+=1024;
*mmu_table++=pageval;
}

// MARK END-OF AVAILABLE RAM
*tblptr=0;

return 1;
}


// MARK END-OF-RAM
*mmu_table=0;

// CODE IS ALIGNED, JUST ADD CODE PAGES TO THE MMU TABLE
code_addr>>=1;
code_addr|=0x03f;
mmu_table=(int *) (((unsigned int)mmu_table&(~0xfff))|512);

while(codesize>0) {
*mmu_table++=code_addr;
code_addr+=1024;
codesize-=2048;
}

return 1;
}



