//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: launch_alloc_ram.c 505 2007-11-04 06:26:42Z claudio $

#include <hpgcc3.h>
#include "launcher.h"

// ALLOCATE RAM AS REQUESTED

int *__launch_addregion(int *MMU_PTR,unsigned startaddr,unsigned endaddr)
{
startaddr+=4095;
startaddr&=~4095;
endaddr&=~4095;

if(startaddr>=endaddr) return MMU_PTR;

if(!MMU_PTR) MMU_PTR=(int *)startaddr;	// CREATE MMU TABLE AT THE BEGNNING OF THE FIRST BLOCK

while(startaddr!=endaddr)
{
*MMU_PTR++=startaddr|0xffe;
startaddr+=4096;
}

return MMU_PTR;
}


int *launch_alloc_ram(unsigned int ram_req, int *kos_mem,SAT_CPU *cpu)
{
int *MMU_PTR=NULL;

*kos_mem=0;

//************************
// KOS MEMORY 
//************************

if(ram_req&0x40000) {
// REQUEST KOS MEMORY AND ADD TO HEAP
int *memptr,size;

// DETECT HOW MUCH FREE KOS MEMORY WE HAVE AVAILABLE
for(size=108*1024;size>4096;size-=4096)
{
memptr=kos_malloc(size);
if(memptr) { kos_free(memptr); break; }
}
size-=16384;		// LEAVE 16K FOR THE OS TO WORK
if(size>4096) {
memptr=kos_malloc(size);
if(memptr) {
MMU_PTR=__launch_addregion(MMU_PTR,(unsigned int)memptr,(unsigned int)memptr+(unsigned int)size);
*kos_mem=(int)memptr;
}

}

}



//************************
// MAIN MEMORY 
//************************

if(ram_req&0x10000)
{
// DETECT HOW MUCH FREE RAM IS AVAILABLE

int rsktop=__launch_peek(SAT_RSKTOP,5,cpu);
int dsktop=__launch_peek(SAT_DSKTOP,5,cpu);

rsktop+=(ram_req&0xff)<<11;	// RESERVE MEMORY FOR TEMPOB GROWTH
dsktop-=((ram_req>>8)&0xff)<<11;  // RESERVE MEMORY FOR STACK/USEROB GROWTH

rsktop=__launch_s2a(rsktop,cpu);
dsktop=__launch_s2a(dsktop,cpu);

MMU_PTR=__launch_addregion(MMU_PTR,(unsigned int)rsktop,(unsigned int)dsktop);

}



//************************
// ERAM MEMORY 
//************************

if(ram_req&0x20000) {
// SCAN ERAM MEMORY DIRECTLY
int start=0x08020000<<1,end=0x08040000;

while(__launch_peekarm(start,5,cpu)!=0) {
start+=5;
start+=__launch_peekarm(start,5,cpu);
}
start+=6;
start>>=1;
MMU_PTR=__launch_addregion(MMU_PTR,(unsigned int)start,(unsigned int)end);

}

return MMU_PTR;

}


